#!/bin/bash

# Dieses Skript konfiguriert easyVDR 0.4.x für den dxr3 Betrieb.
# Autor: Wicky

# Anmerkungen:
# - Ich habe ausschließlich functions verwendet, da sich so besser testen läßt und das Maintaining erleichtert wird.
# - Das Skript kann vom Installer, User und Update-Mechanismus verwendet werden.

# Todo:
# - Die functions activate_Plugin und change_Skin sollten so bald wie möglich durch "Kris-Tool" functions ersetzt werden
# - Logging, Userinfo variabler gestalten ( -> function msg einführen). 
# Sprich je nachdem, wer das Skript aufruft, (Installer, User, Update-Mechanismus)
# unterschiedliche Infos ausgeben, bzw. loggen
# - Feste Pfade durch Variablen ersetzen. !!

vdr_running="false"

function stop_vdr() {
# Ggf. VDR beenden	
	if [ -e /var/run/vdr.pid ]; then
		vdr_running="true"
    	PID=`cat /var/run/vdr.pid` 
      	if [ x"$PID" != "x" ]; then
        	stopvdr >/dev/null 2>/dev/null
      	fi
	fi
}


function config_Mplayer() {
# Mplayer Konfiguration für die dxr3 über das OSD ermöglichen
	if [ -f /etc/vdr/commands.conf ]; then
		typeset -i commands_conf_edited
		commands_conf_edited=0
		commands_conf_edited=$(grep -c 'dxr3' /etc/vdr/commands.conf)
		if [ $commands_conf_edited -lt 1 ]; then
			sed -i '/mp_spur3/ a\-dxr3 normal					: cp /usr/bin/mp_dxr3 /usr/bin/mplayer.sh.conf ' /etc/vdr/commands.conf
		fi
	else
		echo "Error: Die Datei /etc/vdr/commands.conf exisitiert nicht...."
	fi
}

function fix_ModprobeD() {
# Nur falls notwendig, die Dateien im Verzeichnis /etc/modprobe.d in den update-modules Mechanismus der modutils 
# integrieren. Benötigt für dxr3config mit dem Parameter -gm. Siehe auch www.vdr-wiki.de -> dxr3config
	if [ -f /etc/modprobe.conf ] && [ $(grep -c '^include /etc/modprobe.d' < /etc/modprobe.conf) -lt 1 ]; then
		sed -i '1 i\#' /etc/modprobe.conf
		sed -i '2 i\# /etc/modprobe.conf: modprobe(8) configuration' /etc/modprobe.conf
		sed -i '3 i\#' /etc/modprobe.conf
		sed -i '4 i\ ' /etc/modprobe.conf
		sed -i '5 i\include /etc/modprobe.d' /etc/modprobe.conf
	fi
}

function fix_Plugin() {
# Das nicht gepatchte dxr3-plugin entfernen. Eventuell weg lassen ?!
	if [ -f /usr/vdr/more_plugins-1.4.4/libvdr-dxr3.so.1.4.4 ] && [ -f /usr/vdr/plugins-1.4.4/libvdr-dxr3.so.1.4.4 ]; then
		rm /usr/vdr/more_plugins-1.4.4/libvdr-dxr3.so.1.4.4
	fi
}

function activate_Plugin() {
	# dxr3-Plugin aktivieren. Die Zeile sollte durch eien Kris Mechanismus ersetzt werden:
	#überprüfen, ob das dxr3-plugin schon aktiv ist:
	dxr3_plugin_active="false"
	if [ $(grep -c '^PLUGINLIST.*Pdxr3' < /etc/vdr/sysconfig) -lt 1 ]; then
		#sed -i '/PLUGINLIST/s/"$/\ \"-Pdxr3 \\" "/' /etc/vdr/sysconfig
		sed -i 's/^PLUGINLIST="/& \\"-Pdxr3 \\" /g' /etc/vdr/sysconfig  
	fi
	sed -i '/plugin name=\"dxr3\"/s/active=\"no\"/active=\"yes\"/' /etc/vdr/plugins/setup/vdr-setup.xml 
}

function change_Skin() {
	sed -i '/^OSDSkin.*/ c\OSDSkin = enElchi' /etc/vdr/setup.conf
}

# Hauptroutine

# fix_ModprobeD auf jeden Fall ausführen. Das /etc/modprobe.d/ berücksichtigt wird, sollte Standard werden !!
fix_ModprobeD
dxr3_exists=$(lspci -n | grep -w 1105:8300)
# Alles folgende wird nur ausgeführt, wenn eine dxr3 im System steckt !!
if [ -n "$dxr3_exists" ]; then
	echo ""
	echo "Der VDR-Prozess wird falls notwendig beendet..."	
	stop_vdr
	sleep 3
	echo ""
	echo "dxr3config wird gestartet ..."
	dxr3config -a -gm
	fix_Plugin
	echo ""
	echo "Das dxr3-plugin wird aktiviert ..."
	activate_Plugin
	echo "Skin enElchi wird aktiviert ..."
	change_Skin
	echo "Die commands.conf wird erweitert ..."
	config_Mplayer
	# Den VDR starten, falls er gestartet war...
	if [ "x$vdr_running" = "xtrue" ]; then
		echo "Der VDR-Prozess wird gleich wieder gestartet ..."
		startvdr >/dev/null 2>/dev/null
	fi
else
	echo "" 
	echo "Sorry: Es wurde keine dxr3/Hollywood+ MPEG-Decoder-Karte gefunden.."
	echo "Das System wurde daher nicht für eine dxr3 konfiguriert."
	echo ""
fi